diff --git a/tests/unit/modules/test_virt.py b/tests/unit/modules/test_virt.py
index 3e9bd5ef49..d3988464f6 100644
--- a/tests/unit/modules/test_virt.py
+++ b/tests/unit/modules/test_virt.py
@@ -3555,113 +5076,170 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
   <pool type='sheepdog' supported='no'>
   </pool>
 </storagepoolCapabilities>
-        '''
+        """
         self.mock_conn.getStoragePoolCapabilities = MagicMock(return_value=xml_caps)
 
         actual = virt.pool_capabilities()
-        self.assertEqual({
-            'computed': False,
-            'pool_types': [{
-                'name': 'disk',
-                'supported': True,
-                'options': {
-                    'pool': {
-                        'default_format': 'unknown',
-                        'sourceFormatType': ['unknown', 'dos', 'dvh']
-                    },
-                    'volume': {
-                        'default_format': 'none',
-                        'targetFormatType': ['none', 'linux']
-                    }
-                }
-            },
-            {
-                'name': 'iscsi',
-                'supported': True,
-            },
-            {
-                'name': 'rbd',
-                'supported': True,
-                'options': {
-                    'volume': {
-                        'default_format': 'raw',
-                        'targetFormatType': []
-                    }
-                }
-            },
+        self.assertEqual(
             {
-                'name': 'sheepdog',
-                'supported': False,
+                "computed": False,
+                "pool_types": [
+                    {
+                        "name": "disk",
+                        "supported": True,
+                        "options": {
+                            "pool": {
+                                "default_format": "unknown",
+                                "sourceFormatType": ["unknown", "dos", "dvh"],
+                            },
+                            "volume": {
+                                "default_format": "none",
+                                "targetFormatType": ["none", "linux"],
+                            },
+                        },
+                    },
+                    {"name": "iscsi", "supported": True},
+                    {
+                        "name": "rbd",
+                        "supported": True,
+                        "options": {
+                            "volume": {"default_format": "raw", "targetFormatType": []}
+                        },
+                    },
+                    {"name": "sheepdog", "supported": False},
+                ],
             },
-        ]}, actual)
+            actual,
+        )
 
-    @patch('salt.modules.virt.get_hypervisor', return_value='kvm')
+    @patch("salt.modules.virt.get_hypervisor", return_value="kvm")
     def test_pool_capabilities_computed(self, mock_get_hypervisor):
-        '''
+        """
         Test virt.pool_capabilities where libvirt doesn't have the pool-capabilities feature
-        '''
+        """
         self.mock_conn.getLibVersion = MagicMock(return_value=4006000)
         del self.mock_conn.getStoragePoolCapabilities
 
         actual = virt.pool_capabilities()
 
-        self.assertTrue(actual['computed'])
-        backends = actual['pool_types']
+        self.assertTrue(actual["computed"])
+        backends = actual["pool_types"]
 
         # libvirt version matching check
-        self.assertFalse([backend for backend in backends if backend['name'] == 'iscsi-direct'][0]['supported'])
-        self.assertTrue([backend for backend in backends if backend['name'] == 'gluster'][0]['supported'])
-        self.assertFalse([backend for backend in backends if backend['name'] == 'zfs'][0]['supported'])
+        self.assertFalse(
+            [backend for backend in backends if backend["name"] == "iscsi-direct"][0][
+                "supported"
+            ]
+        )
+        self.assertTrue(
+            [backend for backend in backends if backend["name"] == "gluster"][0][
+                "supported"
+            ]
+        )
+        self.assertFalse(
+            [backend for backend in backends if backend["name"] == "zfs"][0][
+                "supported"
+            ]
+        )
 
         # test case matching other hypervisors
-        mock_get_hypervisor.return_value = 'xen'
-        backends = virt.pool_capabilities()['pool_types']
-        self.assertFalse([backend for backend in backends if backend['name'] == 'gluster'][0]['supported'])
+        mock_get_hypervisor.return_value = "xen"
+        backends = virt.pool_capabilities()["pool_types"]
+        self.assertFalse(
+            [backend for backend in backends if backend["name"] == "gluster"][0][
+                "supported"
+            ]
+        )
 
-        mock_get_hypervisor.return_value = 'bhyve'
-        backends = virt.pool_capabilities()['pool_types']
-        self.assertFalse([backend for backend in backends if backend['name'] == 'gluster'][0]['supported'])
-        self.assertTrue([backend for backend in backends if backend['name'] == 'zfs'][0]['supported'])
+        mock_get_hypervisor.return_value = "bhyve"
+        backends = virt.pool_capabilities()["pool_types"]
+        self.assertFalse(
+            [backend for backend in backends if backend["name"] == "gluster"][0][
+                "supported"
+            ]
+        )
+        self.assertTrue(
+            [backend for backend in backends if backend["name"] == "zfs"][0][
+                "supported"
+            ]
+        )
 
         # Test options output
-        self.assertNotIn('options', [backend for backend in backends if backend['name'] == 'iscsi'][0])
-        self.assertNotIn('pool', [backend for backend in backends if backend['name'] == 'dir'][0]['options'])
-        self.assertNotIn('volume', [backend for backend in backends if backend['name'] == 'logical'][0]['options'])
-        self.assertEqual({
-                'pool': {
-                    'default_format': 'auto',
-                    'sourceFormatType': ['auto', 'nfs', 'glusterfs', 'cifs']
+        self.assertNotIn(
+            "options",
+            [backend for backend in backends if backend["name"] == "iscsi"][0],
+        )
+        self.assertNotIn(
+            "pool",
+            [backend for backend in backends if backend["name"] == "dir"][0]["options"],
+        )
+        self.assertNotIn(
+            "volume",
+            [backend for backend in backends if backend["name"] == "logical"][0][
+                "options"
+            ],
+        )
+        self.assertEqual(
+            {
+                "pool": {
+                    "default_format": "auto",
+                    "sourceFormatType": ["auto", "nfs", "glusterfs", "cifs"],
+                },
+                "volume": {
+                    "default_format": "raw",
+                    "targetFormatType": [
+                        "none",
+                        "raw",
+                        "dir",
+                        "bochs",
+                        "cloop",
+                        "dmg",
+                        "iso",
+                        "vpc",
+                        "vdi",
+                        "fat",
+                        "vhd",
+                        "ploop",
+                        "cow",
+                        "qcow",
+                        "qcow2",
+                        "qed",
+                        "vmdk",
+                    ],
                 },
-                'volume': {
-                    'default_format': 'raw',
-                    'targetFormatType': ['none', 'raw', 'dir', 'bochs', 'cloop', 'dmg', 'iso', 'vpc', 'vdi',
-                          'fat', 'vhd', 'ploop', 'cow', 'qcow', 'qcow2', 'qed', 'vmdk']
-                }
             },
-            [backend for backend in backends if backend['name'] == 'netfs'][0]['options'])
+            [backend for backend in backends if backend["name"] == "netfs"][0][
+                "options"
+            ],
+        )
 
     def test_get_domain(self):
-        '''
+        """
         Test the virt._get_domain function
-        '''
+        """
         # Tests with no VM
         self.mock_conn.listDomainsID.return_value = []
         self.mock_conn.listDefinedDomains.return_value = []
         self.assertEqual([], virt._get_domain(self.mock_conn))
-        self.assertRaisesRegex(CommandExecutionError, 'No virtual machines found.',
-                               virt._get_domain, self.mock_conn, 'vm2')
+        self.assertRaisesRegex(
+            CommandExecutionError,
+            "No virtual machines found.",
+            virt._get_domain,
+            self.mock_conn,
+            "vm2",
+        )
 
         # Test with active and inactive VMs
         self.mock_conn.listDomainsID.return_value = [1]
 
         def create_mock_vm(idx):
             mock_vm = MagicMock()
-            mock_vm.name.return_value = 'vm{0}'.format(idx)
+            mock_vm.name.return_value = "vm{0}".format(idx)
             return mock_vm
 
         mock_vms = [create_mock_vm(idx) for idx in range(3)]
         self.mock_conn.lookupByID.return_value = mock_vms[0]
-        self.mock_conn.listDefinedDomains.return_value = ['vm1', 'vm2']
+        self.mock_conn.listDefinedDomains.return_value = ["vm1", "vm2"]
 
         self.mock_conn.lookupByName.side_effect = mock_vms
         self.assertEqual(mock_vms, virt._get_domain(self.mock_conn))
@@ -3672,11 +5250,297 @@ class VirtTestCase(TestCase, LoaderModuleMockMixin):
 
         self.mock_conn.lookupByName.return_value = None
         self.mock_conn.lookupByName.side_effect = [mock_vms[1], mock_vms[2]]
-        self.assertEqual([mock_vms[1], mock_vms[2]], virt._get_domain(self.mock_conn, active=False))
+        self.assertEqual(
+            [mock_vms[1], mock_vms[2]], virt._get_domain(self.mock_conn, active=False)
+        )
 
         self.mock_conn.reset_mock()
         self.mock_conn.lookupByName.return_value = None
         self.mock_conn.lookupByName.side_effect = [mock_vms[1], mock_vms[2]]
-        self.assertEqual([mock_vms[1], mock_vms[2]], virt._get_domain(self.mock_conn, 'vm1', 'vm2'))
-        self.assertRaisesRegex(CommandExecutionError, 'The VM "vm2" is not present',
-                               virt._get_domain, self.mock_conn, 'vm2', inactive=False)
+        self.assertEqual(
+            [mock_vms[1], mock_vms[2]], virt._get_domain(self.mock_conn, "vm1", "vm2")
+        )
+        self.assertRaisesRegex(
+            CommandExecutionError,
+            'The VM "vm2" is not present',
+            virt._get_domain,
+            self.mock_conn,
+            "vm2",
+            inactive=False,
+        )
+
+    def test_volume_define(self):
+        """
+        Test virt.volume_define function
+        """
+        # Normal test case
+        pool_mock = MagicMock()
+        pool_mock.XMLDesc.return_value = "<pool type='dir'></pool>"
+        self.mock_conn.storagePoolLookupByName.return_value = pool_mock
+
+        self.assertTrue(
+            virt.volume_define(
+                "testpool",
+                "myvm_system.qcow2",
+                8192,
+                allocation=4096,
+                format="qcow2",
+                type="file",
+            )
+        )
+
+        expected_xml = (
+            "<volume type='file'>\n"
+            "  <name>myvm_system.qcow2</name>\n"
+            "  <source>\n"
+            "  </source>\n"
+            "  <capacity unit='KiB'>8388608</capacity>\n"
+            "  <allocation unit='KiB'>4194304</allocation>\n"
+            "  <target>\n"
+            "    <format type='qcow2'/>\n"
+            "  </target>\n"
+            "</volume>"
+        )
+
+        pool_mock.createXML.assert_called_once_with(expected_xml, 0)
+
+        # backing store test case
+        pool_mock.reset_mock()
+        self.assertTrue(
+            virt.volume_define(
+                "testpool",
+                "myvm_system.qcow2",
+                8192,
+                allocation=4096,
+                format="qcow2",
+                type="file",
+                backing_store={"path": "/path/to/base.raw", "format": "raw"},
+            )
+        )
+
+        expected_xml = (
+            "<volume type='file'>\n"
+            "  <name>myvm_system.qcow2</name>\n"
+            "  <source>\n"
+            "  </source>\n"
+            "  <capacity unit='KiB'>8388608</capacity>\n"
+            "  <allocation unit='KiB'>4194304</allocation>\n"
+            "  <target>\n"
+            "    <format type='qcow2'/>\n"
+            "  </target>\n"
+            "  <backingStore>\n"
+            "    <path>/path/to/base.raw</path>\n"
+            "    <format type='raw'/>\n"
+            "  </backingStore>\n"
+            "</volume>"
+        )
+
+        pool_mock.createXML.assert_called_once_with(expected_xml, 0)
+
+        # logical pool test case
+        pool_mock.reset_mock()
+        pool_mock.XMLDesc.return_value = "<pool type='logical'></pool>"
+        self.mock_conn.storagePoolLookupByName.return_value = pool_mock
+
+        self.assertTrue(
+            virt.volume_define(
+                "testVG",
+                "myvm_system",
+                8192,
+                backing_store={"path": "/dev/testVG/base"},
+            )
+        )
+
+        expected_xml = (
+            "<volume>\n"
+            "  <name>myvm_system</name>\n"
+            "  <source>\n"
+            "  </source>\n"
+            "  <capacity unit='KiB'>8388608</capacity>\n"
+            "  <allocation unit='KiB'>8388608</allocation>\n"
+            "  <target>\n"
+            "  </target>\n"
+            "  <backingStore>\n"
+            "    <path>/dev/testVG/base</path>\n"
+            "  </backingStore>\n"
+            "</volume>"
+        )
+
+        pool_mock.createXML.assert_called_once_with(expected_xml, 0)
+
+    def test_volume_upload(self):
+        """
+        Test virt.volume_upload function
+        """
+        pool_mock = MagicMock()
+        vol_mock = MagicMock()
+        pool_mock.storageVolLookupByName.return_value = vol_mock
+        self.mock_conn.storagePoolLookupByName.return_value = pool_mock
+        stream_mock = MagicMock()
+        self.mock_conn.newStream.return_value = stream_mock
+
+        open_mock = MagicMock()
+        close_mock = MagicMock()
+        with patch.dict(
+            os.__dict__, {"open": open_mock, "close": close_mock}
+        ):  # pylint: disable=no-member
+            # Normal case
+            self.assertTrue(virt.volume_upload("pool0", "vol1.qcow2", "/path/to/file"))
+            stream_mock.sendAll.assert_called_once()
+            stream_mock.finish.assert_called_once()
+            self.mock_conn.close.assert_called_once()
+            vol_mock.upload.assert_called_once_with(stream_mock, 0, 0, 0)
+
+            # Sparse upload case
+            stream_mock.sendAll.reset_mock()
+            vol_mock.upload.reset_mock()
+            self.assertTrue(
+                virt.volume_upload(
+                    "pool0",
+                    "vol1.qcow2",
+                    "/path/to/file",
+                    offset=123,
+                    length=456,
+                    sparse=True,
+                )
+            )
+            stream_mock.sendAll.assert_not_called()
+            stream_mock.sparseSendAll.assert_called_once()
+            vol_mock.upload.assert_called_once_with(
+                stream_mock,
+                123,
+                456,
+                self.mock_libvirt.VIR_STORAGE_VOL_UPLOAD_SPARSE_STREAM,
+            )
+
+            # Upload unsupported case
+            vol_mock.upload.side_effect = self.mock_libvirt.libvirtError("Unsupported")
+            self.assertRaisesRegex(
+                CommandExecutionError,
+                "Unsupported",
+                virt.volume_upload,
+                "pool0",
+                "vol1.qcow2",
+                "/path/to/file",
+            )
+
+    def test_get_disks(self):
+        """
+        Test the virt.get_disks function
+        """
+        # test with volumes
+        vm_def = """<domain type='kvm' id='3'>
+          <name>srv01</name>
+          <devices>
+            <disk type='volume' device='disk'>
+              <driver name='qemu' type='qcow2' cache='none' io='native'/>
+              <source pool='default' volume='srv01_system'/>
+              <backingStore/>
+              <target dev='vda' bus='virtio'/>
+              <alias name='virtio-disk0'/>
+              <address type='pci' domain='0x0000' bus='0x00' slot='0x04' function='0x0'/>
+            </disk>
+            <disk type='volume' device='disk'>
+              <driver name='qemu' type='qcow2' cache='none' io='native'/>
+              <source pool='default' volume='srv01_data'/>
+              <backingStore type='file' index='1'>
+                <format type='qcow2'/>
+                <source file='/var/lib/libvirt/images/vol01'/>
+                <backingStore/>
+              </backingStore>
+              <target dev='vdb' bus='virtio'/>
+              <alias name='virtio-disk1'/>
+              <address type='pci' domain='0x0000' bus='0x00' slot='0x05' function='0x0'/>
+            </disk>
+            <disk type='volume' device='disk'>
+              <driver name='qemu' type='qcow2' cache='none' io='native'/>
+              <source pool='default' volume='vm05_system'/>
+              <backingStore type='file' index='1'>
+                <format type='qcow2'/>
+                <source file='/var/lib/libvirt/images/vm04_system.qcow2'/>
+                <backingStore type='file' index='2'>
+                  <format type='raw'/>
+                  <source file='/var/testsuite-data/disk-image-template.raw'/>
+                  <backingStore/>
+                </backingStore>
+              </backingStore>
+              <target dev='vdc' bus='virtio'/>
+              <alias name='virtio-disk0'/>
+              <address type='pci' domain='0x0000' bus='0x00' slot='0x04' function='0x0'/>
+            </disk>
+            <disk type='network' device='cdrom'>
+              <driver name='qemu' type='raw' cache='none' io='native'/>
+              <source protocol='http' name='/pub/iso/myimage.iso' query='foo=bar&amp;baz=flurb' index='1'>
+                <host name='dev-srv.tf.local' port='80'/>
+              </source>
+              <target dev='hda' bus='ide'/>
+              <readonly/>
+              <alias name='ide0-0-0'/>
+              <address type='drive' controller='0' bus='0' target='0' unit='0'/>
+            </disk>
+          </devices>
+        </domain>
+        """
+        self.set_mock_vm("srv01", vm_def)
+
+        pool_mock = MagicMock()
+        pool_mock.storageVolLookupByName.return_value.info.return_value = [
+            0,
+            1234567,
+            12345,
+        ]
+        pool_mock.storageVolLookupByName.return_value.XMLDesc.side_effect = [
+            "<volume />",
+            """
+            <volume>
+              <backingStore>
+                <path>/var/lib/libvirt/images/vol01</path>
+                <format type="qcow2"/>
+              </backingStore>
+            </volume>""",
+        ]
+        self.mock_conn.storagePoolLookupByName.return_value = pool_mock
+
+        self.assertDictEqual(
+            virt.get_disks("srv01"),
+            {
+                "vda": {
+                    "type": "disk",
+                    "file": "default/srv01_system",
+                    "file format": "qcow2",
+                    "disk size": 12345,
+                    "virtual size": 1234567,
+                },
+                "vdb": {
+                    "type": "disk",
+                    "file": "default/srv01_data",
+                    "file format": "qcow2",
+                    "disk size": 12345,
+                    "virtual size": 1234567,
+                    "backing file": {
+                        "file": "/var/lib/libvirt/images/vol01",
+                        "file format": "qcow2",
+                    },
+                },
+                "vdc": {
+                    "type": "disk",
+                    "file": "default/vm05_system",
+                    "file format": "qcow2",
+                    "disk size": 12345,
+                    "virtual size": 1234567,
+                    "backing file": {
+                        "file": "/var/lib/libvirt/images/vm04_system.qcow2",
+                        "file format": "qcow2",
+                        "backing file": {
+                            "file": "/var/testsuite-data/disk-image-template.raw",
+                            "file format": "raw",
+                        },
+                    },
+                },
+                "hda": {
+                    "type": "cdrom",
+                    "file format": "raw",
+                    "file": "http://dev-srv.tf.local:80/pub/iso/myimage.iso?foo=bar&baz=flurb",
+                },
+            },
+        )
diff --git a/tests/unit/states/test_virt.py b/tests/unit/states/test_virt.py
index 6727704494..c76f8a5fc0 100644
--- a/tests/unit/states/test_virt.py
+++ b/tests/unit/states/test_virt.py
@@ -1,55 +1,56 @@
 # -*- coding: utf-8 -*-
-'''
+"""
     :codeauthor: Jayesh Kariya <jayeshk@saltstack.com>
-'''
+"""
 # Import Python libs
 from __future__ import absolute_import, print_function, unicode_literals
-import tempfile
-import shutil
 
-# Import Salt Testing Libs
-from tests.support.runtests import RUNTIME_VARS
-from tests.support.mixins import LoaderModuleMockMixin
-from tests.support.unit import TestCase
-from tests.support.mock import (
-    MagicMock,
-    mock_open,
-    patch)
+import shutil
+import tempfile
 
 # Import Salt Libs
 import salt.states.virt as virt
 import salt.utils.files
-from salt.exceptions import CommandExecutionError
+from salt.exceptions import CommandExecutionError, SaltInvocationError
 
 # Import 3rd-party libs
 from salt.ext import six
+from tests.support.mixins import LoaderModuleMockMixin
+from tests.support.mock import MagicMock, mock_open, patch
+
+# Import Salt Testing Libs
+from tests.support.runtests import RUNTIME_VARS
+from tests.support.unit import TestCase
 
 
 class LibvirtMock(MagicMock):  # pylint: disable=too-many-ancestors
-    '''
+    """
     libvirt library mockup
-    '''
+    """
+
     class libvirtError(Exception):  # pylint: disable=invalid-name
-        '''
+        """
         libvirt error mockup
-        '''
+        """
+
         def get_error_message(self):
-            '''
+            """
             Fake function return error message
-            '''
+            """
             return six.text_type(self)
 
 
 class LibvirtTestCase(TestCase, LoaderModuleMockMixin):
-    '''
+    """
     Test cases for salt.states.libvirt
-    '''
+    """
+
     def setup_loader_modules(self):
-        self.mock_libvirt = LibvirtMock()  # pylint: disable=attribute-defined-outside-init
-        self.addCleanup(delattr, self, 'mock_libvirt')
-        loader_globals = {
-            'libvirt': self.mock_libvirt
-        }
+        self.mock_libvirt = (
+            LibvirtMock()
+        )  # pylint: disable=attribute-defined-outside-init
+        self.addCleanup(delattr, self, "mock_libvirt")
+        loader_globals = {"libvirt": self.mock_libvirt}
         return {virt: loader_globals}
 
     @classmethod
